close all
clear all
Mesh.Coordinates = [0 0; 1 0; 1 1; 0 1];
Mesh.Elements = [1 2 3; 1 3 4];
Mesh.ElemFlag = ones(size(Mesh.Elements,1),1);
Mesh = add_Edges(Mesh);
Mesh = add_Edge2Elem(Mesh);
% Mesh.BdFlags = [-1; -1; -1; -1];
Loc = get_BdEdges(Mesh);
Mesh.BdFlags = zeros(size(Mesh.Edges,1),1);
Mesh.BdFlags(Loc) = -1;

hvals = [];
nvals = [];
errs = [];

eps = 1e-6;

v = @(x,varargin)[ones(size(x,1),1), .5-x(:,2)];
u = @(x,varargin)sin(4*pi*x(:,2)).*exp(-x(:,1));
g = @(x,varargin)u(x);
alpha = eps*(1 - 16*pi^2) - 2;
f = @(x,varargin) alpha*u(x) + 4*pi*(0.5-x(:,2)).*cos(4*pi*x(:,2)).*exp(-x(:,1));

for l = 1:7
    Mesh = refine_REG(Mesh);
    for k = 1:5
        Loc = get_BdEdges(Mesh);
        FixedVertices = Mesh.Edges(Loc,:);
        FixedVertices = unique(FixedVertices);
        FixedPos = zeros(size(Mesh.Coordinates,1),1);
        FixedPos(FixedVertices)=1;
        Mesh = smooth(Mesh,FixedPos);
    end

    [A, L, U, FD] = assemble_FV_XD(Mesh, eps, v, g, f);

    L = L - A*U;
    U(FD) = A(FD,FD)\L(FD);

    plot_LFE(U,Mesh)
    hvals = [hvals, get_MeshWidth(Mesh)];
    nvals = [nvals, size(Mesh.Coordinates,1)];
    errs = [errs, L2Err_LFE(Mesh, U, P7O6(), u)];
end
loglog(hvals,errs)
p = polyfit(hvals(3:end),errs(3:end),1);
convrate = p(1)
