close all
clear all
clc

% problem setup

level=10; %continous refinement 

n=10;

FHandle = @(x,varargin) ones(size(x)); % source function
UHandle=@(x,epsilon) x + (exp((x-1)/epsilon)-exp(-1/epsilon))/(exp(-1/epsilon)-1); % exact solution


err=zeros(level,1);
myH=zeros(level,1);


 %epsilon=0.01;
for i=1:level
    N=n*i;

    h=1/N;
    myH(i)=h;

    epsilon=0.01;

    u=solve2pcdbvp(N, epsilon, FHandle);

    x=0:h:1;

    uExact=UHandle(x,epsilon)';
    
    err(i)= sqrt(sum((uExact-u).^2)/N);

    %plot(x,u,'b-',x,uExact,'r-');
    
end

figure
loglog(n:n:level*n,err,'sk-');

if level>1
   
   p=polyfit(log(myH), log(err),1);
   convergence_rate=p(1)

end


